diff -Naur linux-2.6.11.8/drivers/i2c/busses/i2c-actelm7.c linux-2.6.x/drivers/i2c/busses/i2c-actelm7.c
--- linux-2.6.11.8/drivers/i2c/busses/i2c-actelm7.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/drivers/i2c/busses/i2c-actelm7.c	2009-09-06 22:42:40.000000000 +0100
@@ -0,0 +1,451 @@
+/* ------------------------------------------------------------------------- */
+/* i2c-actelm7.c i2c bus driver algorithms for Actel m7 board                */
+/* ------------------------------------------------------------------------- */
+/* Created by steven taffs steventaffs@yahoo.com code based on work by
+ * Peter Milne, D-TACQ Solutions Ltd
+ *
+ * With acknowledgements to i2c-algo-ibm_ocp.c by 
+ * Ian DaSilva, MontaVista Software, Inc. idasilva@mvista.com
+ *
+ * And i2c-algo-pcf.c, which was created by Simon G. Vogl and Hans Berglund:
+ *
+ * Copyright (C) 1995-1997 Simon G. Vogl, 1998-2000 Hans Berglund
+ *  
+ * And which acknowledged Kyösti Mälkki <kmalkki@cc.hut.fi>,
+ * Frodo Looijaard <frodol@dds.nl>, Martin Bailey<mbailey@littlefeet-inc.com>
+ *
+ * Initial release 0.01
+ *
+ * This driver contains the i2c algorithm and bus driver for the actelm7 board
+ * this release don't use interrupt it polls the on-board i2c unit
+ *
+ * TODO:
+ *
+ * Convert driver from a polling to an interrupt driven drivers
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, version 2.
+ */
+
+#include <linux/config.h>
+#include <linux/interrupt.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/delay.h>
+#include <linux/slab.h>
+#include <linux/init.h>
+#include <linux/errno.h>
+#include <linux/sched.h>
+#include <linux/device.h>
+#include <linux/i2c.h>
+#include <asm/arch/hardware.h>
+
+#include "i2c-actelm7.h"
+
+//define prototypes
+static inline unsigned char i2c_cook_addr(struct i2c_msg *msg);
+uint8_t i2c_send_start_bit(void);
+uint8_t i2c_wait_event(void);
+static void m7_i2c_transaction_cleanup(struct i2c_algo_m7_data *m7_adap);
+static int m7_i2c_send_target_addr(struct i2c_algo_m7_data *m7_adap, struct i2c_msg* msg);
+static int m7_i2c_write_byte(struct i2c_algo_m7_data *m7_adap, char byte);
+static int m7_i2c_read_byte(struct i2c_algo_m7_data *m7_adap, char* byte);
+static int m7_i2c_writebytes(struct i2c_adapter *i2c_adap, const char *buf, int count);
+static int m7_i2c_readbytes(struct i2c_adapter *i2c_adap, char *buf, int count);
+static int m7_i2c_unit_init(void);
+static u32 m7_i2c_func(struct i2c_adapter *adap);
+
+/* global unit counter */
+static int i2c_id = 0;
+
+static inline unsigned char 
+i2c_cook_addr(struct i2c_msg *msg) 
+{
+	unsigned char addr;
+
+	addr = (msg->addr << 1);
+
+	if (msg->flags & I2C_M_RD){
+		addr |= 1;
+		
+	}
+
+	/*
+	 * read or Write?
+	 */
+	if (msg->flags & I2C_M_REV_DIR_ADDR){
+		addr ^= 1;
+
+	}
+
+	return addr;   
+}
+
+uint8_t i2c_send_start_bit(void)
+{	
+	//send a start bit
+    I2C_CNTR |= M7_I2C_CR_SET_START;
+
+	//clear interrupt
+    I2C_CNTR &= M7_I2C_CR_CLEAR_SI;
+    
+	if(i2c_wait_event() != 0){
+		printk("i2c timeout error when sending start bit.\n");
+		return -ETIMEDOUT;		//report error
+	} else {
+		 //clear start bit
+    	I2C_CNTR &= M7_I2C_CR_CLEAR_START;
+		return 0;	
+	}
+}
+
+uint8_t i2c_wait_event(void)
+{
+	int timeout;
+
+	timeout = TIMEOUT_VALUE;
+    //wait for interrupt flag
+  	while (timeout-- && ((I2C_CNTR & M7_I2C_CR_SET_SI) != 1)) 
+  	{
+		//add small 100us delay
+	}
+	
+	//check for errors
+	if(timeout == 0){
+			return -ETIMEDOUT; //report if we have one
+	} else {
+			return 0; 
+	} 
+}
+
+static void 
+m7_i2c_transaction_cleanup(struct i2c_algo_m7_data *m7_adap)
+{
+	
+	//make sure I2C unit is off
+  	I2C_CNTR = M7_I2C_CR_DISABLE_ENS1;  
+    //set units clock speed
+    I2C_CNTR |= M7_I2C_CR_PCLK_DIVIDE_160;  
+    //enable I2C unit
+    I2C_CNTR |= M7_I2C_CR_ENABLE_ENS1;
+}
+
+static int 
+m7_i2c_send_target_addr(struct i2c_algo_m7_data *m7_adap, 
+				struct i2c_msg* msg)
+{
+
+	//load device address and direction into data reg
+	I2C_DATA = i2c_cook_addr(msg);
+
+	//clear interrupt
+    I2C_CNTR &= M7_I2C_CR_CLEAR_SI;
+    	
+    if(i2c_wait_event() != 0){
+		//set stop bit in control reg
+		I2C_CNTR |= M7_I2C_CR_STO;
+		//clear interrupt 
+    	I2C_CNTR &= M7_I2C_CR_CLEAR_SI;
+    	//wait until stop bit is sent
+		i2c_wait_event();
+		printk("i2c timeout error sending target address.\n");
+		return -ETIMEDOUT;		//report error
+	}	
+    	
+	//check for ack
+	if(I2C_STATUS == M7_I2C_SR_SLA_TRANS_ACKED || I2C_STATUS == M7_I2C_SR_SLA_REC_ACKED){
+			return 0;	
+	} else {
+			//set stop bit in control reg
+			I2C_CNTR |= M7_I2C_CR_STO;
+			//clear interrupt 
+    		I2C_CNTR &= M7_I2C_CR_CLEAR_SI;
+    		//wait until stop bit is sent
+			i2c_wait_event();
+			printk("i2c nack received when sending target address \n");
+			return -EREMOTEIO;	//report error
+	}
+}
+
+static int 
+m7_i2c_write_byte(struct i2c_algo_m7_data *m7_adap, char byte)
+{		
+	unsigned char i2c_status = 0x00;
+
+	I2C_DATA = byte;
+    	//clear interrupt
+    	I2C_CNTR &= M7_I2C_CR_CLEAR_SI;
+    	
+    	if(i2c_wait_event() != 0){
+			//set stop bit in control reg
+			I2C_CNTR |= M7_I2C_CR_STO;
+			//clear interrupt 
+    		I2C_CNTR &= M7_I2C_CR_CLEAR_SI;
+    		//wait until stop bit is sent
+			i2c_wait_event();
+			printk("i2c timeout error writing byte.\n");
+			return -ETIMEDOUT;	//report error
+		}		
+    	
+		//check for nack
+		if(I2C_STATUS != M7_I2C_SR_DATA_TRANS_ACKED){
+			i2c_status = I2C_STATUS;
+			//set stop bit in control reg
+			I2C_CNTR |= M7_I2C_CR_STO;
+			//clear interrupt 
+    		I2C_CNTR &= M7_I2C_CR_CLEAR_SI;
+    		//wait until stop bit is sent
+			i2c_wait_event();
+			printk("i2c nack error writing byte status=%02x \n", i2c_status);
+			return -EREMOTEIO; //report error
+		}
+
+		return 0;
+
+}
+
+static int 
+m7_i2c_read_byte(struct i2c_algo_m7_data *m7_adap, char* byte)
+{
+		unsigned char i2c_status = 0x00;
+
+		//get the next byte and ack response
+    	I2C_CNTR |= M7_I2C_CR_SET_AA_BIT;
+    	//clear interrupt
+    	I2C_CNTR &= M7_I2C_CR_CLEAR_SI;
+
+		//wait for data to be sent
+    	if(i2c_wait_event() != 0){
+    		//set stop bit in control reg
+			I2C_CNTR |= M7_I2C_CR_STO;
+			//clear interrupt 
+    		I2C_CNTR &= M7_I2C_CR_CLEAR_SI;
+    		//wait until stop bit is sent
+			i2c_wait_event();
+			printk("i2c timeout error reading byte. \n");
+			return -ETIMEDOUT;	//report error
+		}
+
+		//check for ack
+		if(I2C_STATUS == M7_I2C_SR_DATA_REC_ACKED){
+			//save data
+			*byte = I2C_DATA;
+		} else {
+			//set stop bit in control reg
+			I2C_CNTR |= M7_I2C_CR_STO;
+			//clear interrupt 
+    		I2C_CNTR &= M7_I2C_CR_CLEAR_SI;
+    		//wait until stop bit is sent
+			i2c_wait_event();
+			printk("i2c nack error reading byte status=%02x \n", i2c_status);
+			return -EREMOTEIO;	//report error
+		}
+
+		return 0;
+}
+
+static int 
+m7_i2c_writebytes(struct i2c_adapter *i2c_adap, const char *buf, int count)
+{
+	struct i2c_algo_m7_data *m7_adap = i2c_adap->algo_data;
+	int ii;
+	int rc = 0;
+
+	for (ii = 0; rc == 0 && ii < count; ++ii) 
+		rc = m7_i2c_write_byte(m7_adap, buf[ii]);
+	return rc;
+
+}
+
+static int 
+m7_i2c_readbytes(struct i2c_adapter *i2c_adap, char *buf, int count)
+{
+	struct i2c_algo_m7_data *m7_adap = i2c_adap->algo_data;
+	int ii;
+	int rc = 0;
+
+	for (ii = 0; rc == 0 && ii < count; ++ii) {
+		rc = m7_i2c_read_byte(m7_adap, &buf[ii]);
+	}
+	return rc;
+}
+
+/*
+ * master_xfer() - main read/write entry
+ */
+static int 
+m7_i2c_master_xfer(struct i2c_adapter *i2c_adap, struct i2c_msg msgs[], 
+				int num)
+{
+	struct i2c_algo_m7_data *m7_adap = i2c_adap->algo_data;
+	struct i2c_msg* pmsg;
+	int im = 0;
+	int rc = 0;
+
+	for (im = 0; im < num; im++) {
+
+		pmsg = &msgs[im];
+
+		/*printk("i2c-actelm7.o: Doing %s %d bytes to 0x%02x - %d of %d messages\n",
+		     pmsg->flags & I2C_M_RD ? "read" : "write",
+                     pmsg->len, pmsg->addr, im + 1, num);*/
+	
+		//first message to be transmitted so send first start bit
+		if(im == 0){
+			/* printk("i2c sending first start bit \n"); */
+			if(i2c_send_start_bit() != 0){
+				printk("i2c timeout error after sending first start bit\n");
+				return -ETIMEDOUT;
+			}
+		}
+
+		//after every start or repeated start the devices address needs to be sent
+		/* printk("i2c sending target address.\n"); */
+		rc = m7_i2c_send_target_addr(m7_adap, pmsg);
+		if (rc < 0) {
+			return rc;
+		}
+
+		//check for read
+		if ((pmsg->flags&I2C_M_RD)) {
+			/* printk("i2c reading byte.\n"); */
+			rc = m7_i2c_readbytes(i2c_adap, pmsg->buf, pmsg->len);
+			if (rc < 0) {
+				return rc;
+			}
+		} else {
+			//must be a write
+			/* printk("i2c writing byte.\n"); */
+			rc =  m7_i2c_writebytes(i2c_adap, pmsg->buf, pmsg->len);
+			if (rc < 0) {
+				return rc;
+			}
+		}
+
+		//do we need to send a stop bit ?	
+		if ((im + 1) == num) {
+			/* printk("sending stop bit\n"); */
+			//yes so set stop bit in control reg
+			I2C_CNTR |= M7_I2C_CR_STO;
+			//clear interrupt 
+    		I2C_CNTR &= M7_I2C_CR_CLEAR_SI;
+    	
+    		if(i2c_wait_event() != 0){
+				printk("i2c timeout error sending stop bit. \n");
+				return -ETIMEDOUT; 
+			}		//report error
+    	
+			//make sure line is idle
+			if(I2C_STATUS != M7_I2C_SR_IDLE_STATE){
+				printk("i2c error line not idle after sending stop bit\n");
+				return -EREMOTEIO; //report error
+			} else {
+				//clear interrupt 
+    			I2C_CNTR &= M7_I2C_CR_CLEAR_SI; 
+			}
+		}else {				//send repeated start bit
+			/* printk("sending repeated start bit\n"); */
+			if(i2c_send_start_bit() != 0){
+				printk("i2c timeout error after sending repeated start\n");
+				return -ETIMEDOUT;
+			}
+		}
+	}
+
+	/* printk("i2c transaction completed ok.\n"); */
+
+	//put i2c unit into its idle state
+	m7_i2c_transaction_cleanup(m7_adap);
+
+	return im;   
+}
+
+static struct i2c_algorithm m7_i2c_algo = {
+	.name			= "m7 I2C algorithm",
+	.id			= I2C_ALGO_EXP,			
+	.master_xfer		= m7_i2c_master_xfer,
+	.functionality		= m7_i2c_func,
+};
+
+static struct i2c_adapter m7_adapter = {
+	.owner		= THIS_MODULE,
+	.algo		= &m7_i2c_algo,
+	.name		= "m7 adapter",
+	.id		= I2C_HW_M7,
+};
+
+static int m7_i2c_unit_init(void)
+{
+	//init adapter data struct
+	int ret;
+
+	struct i2c_algo_m7_data *adapter_data;
+	adapter_data = kmalloc(sizeof(struct i2c_algo_m7_data), GFP_KERNEL);
+	if (!adapter_data) {
+		ret = -ENOMEM;
+		goto free_adapter;
+	}
+	
+	memset((void*)adapter_data, 0, sizeof(*adapter_data));
+	
+	/* set the adapter enumeration # */
+	adapter_data->id = i2c_id++;
+	
+	m7_adapter.algo_data = adapter_data;
+
+	//make sure I2C unit is off
+  	I2C_CNTR = M7_I2C_CR_DISABLE_ENS1; 
+  	//load units slave address
+  	I2C_ADDR0 = MY_SLAVE_ADDR;
+    //set units clock speed
+    I2C_CNTR |= M7_I2C_CR_PCLK_DIVIDE_160;  
+     //enable I2C unit
+    I2C_CNTR |= M7_I2C_CR_ENABLE_ENS1;
+
+	if(I2C_STATUS == M7_I2C_SR_IDLE_STATE)
+	{
+		printk("i2c-actelm7.o: detected and initialized i2c unit.\n");
+		return 0;
+	}
+	else
+	{
+		return -ENXIO;	
+	}
+	
+free_adapter:
+	kfree(adapter_data);
+
+	return ret;
+}
+
+static u32 
+m7_i2c_func(struct i2c_adapter *adap)
+{
+	return I2C_FUNC_I2C | I2C_FUNC_SMBUS_EMUL;
+}
+
+static int __init i2c_m7_init(void)
+{
+	int rval;
+	rval = m7_i2c_unit_init();
+	if (!rval) {
+		i2c_add_adapter(&m7_adapter); 
+	}
+	return rval;
+	
+}
+
+static void __exit i2c_m7_exit(void)
+{
+	struct i2c_algo_m7_data *m7_adap = m7_adapter.algo_data;
+	kfree(m7_adap);
+	i2c_del_adapter(&m7_adapter);
+}
+
+module_init (i2c_m7_init);
+module_exit (i2c_m7_exit);
+
+MODULE_AUTHOR("steven taffs" steventaffs@yahoo.com);
+MODULE_DESCRIPTION("actelm7 i2c algorithm and adapter");
+MODULE_LICENSE("GPL");
diff -Naur linux-2.6.11.8/drivers/i2c/busses/i2c-actelm7.h linux-2.6.x/drivers/i2c/busses/i2c-actelm7.h
--- linux-2.6.11.8/drivers/i2c/busses/i2c-actelm7.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/drivers/i2c/busses/i2c-actelm7.h	2009-09-06 22:42:40.000000000 +0100
@@ -0,0 +1,95 @@
+/* ------------------------------------------------------------------------- */
+/* i2c-actelm7.h algorithm driver definitions private to i2c-actelm7.c       */
+/* ------------------------------------------------------------------------- */
+/*  Created by steven taffs based on code by Peter Milne, D-TACQ Solutions Ltd
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation, version 2.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                */
+/* ------------------------------------------------------------------------- */
+
+
+#ifndef I2C_ACTELM7_H
+#define I2C_ACTELM7_H 1
+
+/*
+ * actel m7 hardware bit definitions
+ */
+
+/* I2C control reg */
+
+
+#define M7_I2C_CR_PCLK_DIVIDE_256		0x00
+#define M7_I2C_CR_PCLK_DIVIDE_224		0x01
+#define M7_I2C_CR_PCLK_DIVIDE_192		0x02
+#define M7_I2C_CR_PCLK_DIVIDE_160		0x03
+#define M7_I2C_CR_PCLK_DIVIDE_960		0x80
+#define M7_I2C_CR_PCLK_DIVIDE_120		0x81
+#define M7_I2C_CR_PCLK_DIVIDE_60		0x82
+#define M7_I2C_CR_BCLK_DIVIDE_8			0x83
+#define M7_I2C_CR_CLEAR_SI				0xf7	/* Clear interrupts */
+#define M7_I2C_CR_SET_SI				0x08
+#define M7_I2C_CR_ENABLE_ENS1			0x40	/* 1=Unit Enable */
+#define M7_I2C_CR_DISABLE_ENS1			0x00
+#define M7_I2C_CR_NACK					0x00	/* 0=reply with NACK */
+#define M7_I2C_CR_ACK					0x04	/* 1=reply with ACK */
+#define M7_I2C_CR_STO					0x10	/* 1=send a STOP */
+#define M7_I2C_CR_SET_START				0x20	/* 1=initiate a START */
+#define M7_I2C_CR_CLEAR_START			0xDF
+#define M7_I2C_CR_SET_AA_BIT			0x04
+
+
+/* I2C status reg (master transmit mode) */
+
+#define M7_I2C_SR_SLA_TRANS_ACKED				0x18
+#define M7_I2C_SR_SLA_TRANS_NACKED				0x20
+#define M7_I2C_SR_DATA_TRANS_ACKED				0x28
+#define M7_I2C_SR_DATA_TRANS_NACKED				0x30
+#define M7_I2C_SR_ARBITRATION_LOST				0x38
+
+/* I2C status reg (master receive mode) */
+
+#define M7_I2C_SR_SLA_REC_ACKED					0x40
+#define M7_I2C_SR_SLA_REC_NACKED				0x48
+#define M7_I2C_SR_DATA_REC_ACKED				0x50
+#define M7_I2C_SR_DATA_REC_NACKED				0x58
+
+/* I2C status reg (Miscellaneous States) */
+
+#define M7_I2C_SR_START							0x08
+#define M7_I2C_SR_REP_START						0x10
+#define M7_I2C_SR_IDLE_STATE					0xF8
+#define M7_I2C_SR_BUS_ERROR						0x00
+
+/* I2C data reg */
+
+#define M7_I2C_DR_WRITE_BIT						0x00
+#define M7_I2C_DR_READ_BIT						0x01
+
+
+#define MY_SLAVE_ADDR			0x02	/* SWAG a suitable slave address */
+
+#define TIMEOUT_VALUE 0xFF
+
+
+#define	CR_OFFSET		0
+#define	SR_OFFSET		0x4
+#define	DBR_OFFSET		0x8
+#define	SAR_OFFSET		0xc
+
+#define I2C_HW_M7		0x00
+
+struct i2c_algo_m7_data {
+	int id;
+};
+
+#endif /* I2C_ACTELM7_H */
diff -Naur linux-2.6.11.8/drivers/i2c/busses/Kconfig linux-2.6.x/drivers/i2c/busses/Kconfig
--- linux-2.6.11.8/drivers/i2c/busses/Kconfig	2005-04-30 02:31:03.000000000 +0100
+++ linux-2.6.x/drivers/i2c/busses/Kconfig	2009-09-06 22:42:40.000000000 +0100
@@ -5,6 +5,13 @@
 menu "I2C Hardware Bus support"
 	depends on I2C
 
+config I2C_ACTELM7
+	tristate "i2c Actelm7"
+	depends on I2C
+	help
+	  if you say yes to this option, support will be included for the
+	  actelm7 i2c core.
+
 config I2C_ALI1535
 	tristate "ALI 1535"
 	depends on I2C && PCI && EXPERIMENTAL
diff -Naur linux-2.6.11.8/drivers/i2c/busses/Makefile linux-2.6.x/drivers/i2c/busses/Makefile
--- linux-2.6.11.8/drivers/i2c/busses/Makefile	2005-04-30 02:33:23.000000000 +0100
+++ linux-2.6.x/drivers/i2c/busses/Makefile	2009-09-06 22:42:40.000000000 +0100
@@ -2,6 +2,7 @@
 # Makefile for the i2c bus drivers.
 #
 
+obj-$(CONFIG_I2C_ACTELM7)	+= i2c-actelm7.o
 obj-$(CONFIG_I2C_ALI1535)	+= i2c-ali1535.o
 obj-$(CONFIG_I2C_ALI1563)	+= i2c-ali1563.o
 obj-$(CONFIG_I2C_ALI15X3)	+= i2c-ali15x3.o
